/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is 
 * Jean-Marc Bastide <jmbastide@gmail.com>
 *
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var fireform_learnfields={
   profsnames:new Array()
    };

fireform_learnfields.create_line=function(item,num,trigger,val,prof)
{
var doc=document.getElementById("fireform-strings");
var learn_new_field=doc.getString("learn_new_field");
var model=document.createElement("row");
var tb=document.createElement("textbox");tb.id="val"+num;tb.setAttribute('value',val);
var cb=document.createElement("checkbox");cb.id="check"+num;cb.setAttribute("label",trigger);
if (val!="") cb.setAttribute("checked","true");
var lb=document.createElement("label");lb.setAttribute("control","ml");lb.setAttribute('value',doc.getString("learn_as"));
var ml=document.createElement("menulist");ml.id="ml";
var mp=document.createElement("menupopup");
var select=0;
for (var i in prof) 
{var mi=document.createElement("menuitem");mi.setAttribute("label",prof[i].desc);
  mp.appendChild(mi);
 if ((val!="") && (prof[i].value==val)) {select=i;mi.setAttribute("selected","true");cb.setAttribute("checked",false)}
}
var mi=document.createElement("menuitem");mi.setAttribute("label",learn_new_field);
mp.appendChild(mi);
if (select==0) mi.setAttribute("selected","true");
ml.appendChild(mp);
model.appendChild(cb);

model.appendChild(tb);
var hb=document.createElement("hbox");
hb.appendChild(lb);
hb.appendChild(ml);
model.appendChild(hb);
var sp=document.createElement("spacer");
model.appendChild(sp);
item.appendChild(model);
}

fireform_learnfields.loadlearn=function(currentprofile)
{
var doc=document.getElementById("fireform-strings");
var proftemp=999999;
var grbase=document.getElementById("grbase");

while (grbase.firstChild) grbase.removeChild(grbase.firstChild); //remove previous display
var newprof=Array();
fireform_load1prof(newprof,proftemp);

var learnprof=Array();

if (!currentprofile)
if (fireform_prefs.prefHasUserValue("currentprofile")) 
	{    currentprofile=parseInt(fireform_prefs.getCharPref("currentprofile"));
	
	var i=1;
    while (fireform_prefs.prefHasUserValue("profiles.prof"+i+".name"))
    {var name=fireform_prefs.getCharPref("profiles.prof"+i+".name");
     document.getElementById("profile_list").appendItem(name,name);
     this.profsnames[i]=name;
     i++;
    }
    document.getElementById("profile_list").appendItem(doc.getString("learn_new_prof"),doc.getString("learn_new_prof"));
    document.getElementById("profile_list").selectedIndex=currentprofile-1;
	}
fireform_load1prof(learnprof,currentprofile);
	
for(var i in newprof) 
   fireform_learnfields.create_line(grbase,i,newprof[i].trigger,newprof[i].value,learnprof);
   
var url=document.getElementById("urlthissite");
url.value=newprof[1].url;

}//loadlearn

fireform_learnfields.saveprofile=function(win)
{ 
var doc=document.getElementById("fireform-strings");

var url='';
var thissiteonly=document.getElementById("thissiteonly").hasAttribute('checked');
if (thissiteonly) url=document.getElementById("urlthissite").value;

var i=1;
var newprof = {value: ""};
var check = {value: false};

var profnum=document.getElementById("profile_list").selectedIndex+1;

if (!fireform_prefs.prefHasUserValue("profiles.prof"+profnum+".name")) //create new
{
do {
if (!fireform_prompts.prompt(window, doc.getString("create_profile_title"), doc.getString("ask_profile_name"), newprof, null, check)) return;
var ok=true;
for (var p in this.profsnames) if (this.profsnames[p]==newprof.value) ok=false;
if (!ok) fireform_localert("already_exists");
} while (!ok);

fireform_prefs.setCharPref("profiles.prof"+profnum+".name",newprof.value);
}

var fieldnum=1;
while (fireform_prefs.prefHasUserValue("profiles.prof"+profnum+".field"+fieldnum+".desc")) fieldnum++;

cb=document.getElementById("check"+i);
while (cb)
  {if (cb.hasAttribute('checked'))
  {
   var val=document.getElementById("val"+i);
   fireform_save1line(profnum,fieldnum,'automatic ('+val.value+')',val.value,cb.label,url);
   fieldnum++;
  }
i++;
cb=document.getElementById("check"+i);
}

}//saveprofile
