/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is 
 * Jean-Marc Bastide <jmbastide@gmail.com>
 *
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
 
var fireform_setup={
profs:new Array(),
profsnames:new Array(),
shortkeys:new Array(),
currentprofile:0,
groups:new Array(),
version:0,
options:{overwrite:false,
         onlyonce:false,
         fgcountry:"us",
         fglanguage:"en",
         fggender:"a"
        }
}; //fireform_setup;

function fireform_setup_group(name,childs)
{
this.name=name;
this.childs=childs;
}

fireform_setup.addcopy_profile=function(option)
{ // add or copy a profile

if ((option=="copy") && (this.currentprofile<1)) return; // no profile yet
var oldprofile=this.currentprofile;

var doc=document.getElementById("fireform-strings");
// ask for name

var newprof = {value: ""};
var check = {value: false};

do {
if (!fireform_prompts.prompt(window, doc.getString("create_profile_title"), doc.getString("ask_profile_name"), newprof, null, check)) return;
var ok=true;
for (var p in this.profsnames) if (this.profsnames[p]==newprof.value) ok=false;
if (!ok) fireform_localert("already_exists");
} while (!ok);

this.currentprofile=this.profs.length;
if (this.currentprofile==0) this.currentprofile=1;
this.profsnames[this.currentprofile]=newprof.value;
var list=document.getElementById("profile_list");
list.appendItem(newprof.value,newprof.value);
list.selectedIndex=document.getElementById("prof_menu").childNodes.length-1;

if (option=="copy") 
{ this.profs[this.currentprofile]=new Array();
  for (var o in this.profs[oldprofile]) 
  this.profs[this.currentprofile][o]=new fireform_profile(this.profs[oldprofile][o].desc,this.profs[oldprofile][o].value,this.profs[oldprofile][o].trigger,this.profs[oldprofile][o].url); //clone
}
else
{
	this.profs[this.currentprofile]=new Array();
	var i=1;
	while (fireform_getstring("default.field"+i+".desc")!=null) //setup default values
	{
	this.profs[this.currentprofile][i]=new fireform_profile(doc.getString("default.field"+i+".desc"),doc.getString("default.field"+i+".value"),doc.getString("default.field"+i+".trigger"),"");
	i++;
	} //while
}	
this.shortkeys[this.currentprofile]="";
this.display_profile();

}//addcopy_profile

fireform_setup.clear_fields=function()
{
 for(var i in this.profs[this.currentprofile]) 
    this.profs[this.currentprofile][i]={desc:"",value:"",trigger:"",url:""};
 this.display_profile();

}// clear_fields

fireform_setup.export_profiles=function()
{

var doc =document.getElementById("fireform-strings");
var xmldoc = document.implementation.createDocument("", "", null);
xmldoc.async = false; 
var ff=xmldoc.createElement('fireform_profiles');
var exported=0;
for(var i in this.profsnames) 
{ var pname=xmldoc.createElement('profile');
  pname.setAttribute("name", this.profsnames[i]);
  if ((this.shortkeys[i]) && (this.shortkeys[i]!="")) pname.setAttribute("shortkey", this.shortkeys[i]);
  for(var j in this.profs[i])
    if (this.profs[i][j].desc+this.profs[i][j].value+this.profs[i][j].trigger!="")
    {
      var field=xmldoc.createElement('field');
      field.setAttribute("desc", this.profs[i][j].desc);
      field.setAttribute("value", this.profs[i][j].value);
      field.setAttribute("trigger", this.profs[i][j].trigger);
      field.setAttribute("url", this.profs[i][j].url);
      pname.appendChild(field);
    }
ff.appendChild(pname);
exported++;
}
xmldoc.appendChild(ff);

var nsIFilePicker = Components.interfaces.nsIFilePicker;
var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
fp.init(window, doc.getString("exportfile"), nsIFilePicker.modeSave);
fp.appendFilters(nsIFilePicker.filterXML,"xml","xml");
//fp.appendFilter("fireform profiles (xml)","*.xml");
fp.defaultExtension="xml";
fp.defaultString=".xml";
var res = fp.show();
if (res == nsIFilePicker.returnCancel) return;

var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
                         .createInstance(Components.interfaces.nsIFileOutputStream);

foStream.init(fp.file, 0x02 | 0x08 | 0x20, 0664, 0); // write, create, truncate

var xmls = new XMLSerializer();
xmls.serializeToStream(xmldoc,foStream,"UTF-8");
foStream.close();

var msg=new Array();msg[0]=exported;
alert(doc.getFormattedString("profilesexported",msg));  

} //export_profiles

fireform_setup.import_profiles=function()
{
var doc =document.getElementById("fireform-strings");
var nsIFilePicker = Components.interfaces.nsIFilePicker;
var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
fp.init(window, doc.getString("importfile"), nsIFilePicker.modeOpen);
fp.appendFilters(nsIFilePicker.filterXML);

//fp.appendFilter("fireform profiles (xml)","*.xml");
var res = fp.show();
if (res == nsIFilePicker.returnCancel) return;

var fistream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
fistream.init(fp.file, -1, 0, 0);

var parser = new DOMParser();
var xmldoc = parser.parseFromStream(fistream, 0 , 1000000, "text/xml");
fistream.close();
var nbimported=fireform_importxml(this,xmldoc);
var msg=new Array();msg[0]=nbimported;
alert(doc.getFormattedString("profilesimported",msg));   
if ((this.currentprofile<=0) && (nbimported>0))
	{ document.getElementById("profile_list").selectedIndex=0;
	  this.select_profile();
	}

} //import_profiles


fireform_setup.del_profile=function()
{
if (this.currentprofile<=0) return;
delete this.profsnames[this.currentprofile];
delete this.profs[this.currentprofile];

var list=document.getElementById("profile_list");
var i=list.selectedIndex;
list.removeItemAt(i);
var max=document.getElementById("prof_menu").childNodes.length-1;
if (i>max) i=max;
list.selectedIndex=i;
this.select_profile();
} //delete_profile

fireform_setup.delall_profiles=function()
{
for (var i in this.profs) { delete this.profs[i];delete this.profsnames[i];}
var list=document.getElementById("profile_list");
while (document.getElementById("prof_menu").childNodes.length>0) list.removeItemAt(0);
list.selectedIndex=0;
this.select_profile();
this.currentprofile=0;
} //delall_profiles

fireform_setup.display_profile=function()
{

fireform_setup.create_line=function(attrib,label,val,disable,group)
{
var clone=model.cloneNode(true);
clone.childNodes[0].setAttribute("value",label);
clone.childNodes[1].setAttribute("value",val);
if (disable) clone.childNodes[1].disabled="true";

var cattrib="";
for(var j in group)
   cattrib+="fireform_setup.profs["+fireform_setup.currentprofile+"]["+group[j]+"]."+attrib+"=event.target.value;";
clone.childNodes[1].setAttribute("onchange",cattrib); 
 
return clone;
}// create line

fireform_setup.create_trigger_box=function(element,num,disable,group)
{
var desc_label=fireform_getstring("label.desc");
var value_label=fireform_getstring("label.value");

var cp=this.profs[this.currentprofile];

var row1=document.createElement("hbox");row1.setAttribute("flex","1");
var cap1=document.createElement("caption");cap1.setAttribute("flex","1");cap1.setAttribute("style","background-color:transparent");

var hb=fireform_setup.create_line("desc",desc_label,cp[num].desc,disable,group);
cap1.appendChild(hb);

var hb=fireform_setup.create_line("value",value_label,cp[num].value,disable,group);hb.setAttribute("style","background-color:white");
cap1.appendChild(hb);

var sp=document.createElement("spacer");sp.setAttribute("flex","10");
cap1.appendChild(sp);

var bt=document.createElement("button");bt.setAttribute("label",'+');bt.setAttribute("style","min-width: 10px");
bt.setAttribute("oncommand","fireform_setup.add_new_trigger("+num+")");
//bt.setAttribute("accessible","false");
cap1.appendChild(bt);

//var sp=document.createElement("spacer");sp.setAttribute("flex","10");
//cap1.appendChild(sp);

element.insertBefore(cap1,element.firstChild); //human logic?
//element.appendChild(cap1);
} //create trigger_box

fireform_setup.create_trigger_line=function(element,num,disable)
{
var trigger_label=fireform_getstring("label.trigger");
var url_label=fireform_getstring("label.url");
var cp=this.profs[this.currentprofile];

var rowk=document.createElement("hbox");rowk.id="triggerline"+num;rowk.setAttribute("flex","1");

var hb=fireform_setup.create_line("url",url_label,cp[num].url,disable,[num]);
rowk.appendChild(hb);
var hb=fireform_setup.create_line("trigger",trigger_label,cp[num].trigger,disable,[num]);
rowk.appendChild(hb);
var bt=document.createElement("button");bt.setAttribute("label",'-');bt.setAttribute("style","min-width: 2px");
bt.setAttribute("oncommand","fireform_setup.del_trigger("+num+")");
bt.setAttribute("style","min-width:10px");
bt.setAttribute("class","dialog");
rowk.appendChild(bt);
element.appendChild(rowk);
} //create trigger line

// shortkeys
if (this.currentprofile)
{
var shortkey=document.getElementById("fireform-short");
shortkey.setAttribute("onchange", "fireform_setup.shortkeys["+this.currentprofile+"]=event.target.value");
shortkey.value=this.shortkeys[this.currentprofile];
}
  
if (!document.getElementById("fireform_setup_dialog")) {fireform_setup.display_simple_profile();return;}
var rows=document.getElementById("rows");

var displayed=Array();

// create a template box, should it be in xul?
var model=document.createElement("hbox");model.setAttribute("flex","10");
var lb=document.createElement("label");lb.setAttribute("control","textbox");
var tb=document.createElement("textbox");tb.id="textbox";tb.setAttribute("flex","1");
model.appendChild(lb);
model.appendChild(tb);

var cp=this.profs[this.currentprofile];

while(rows.firstChild) rows.removeChild(rows.firstChild); //remove previous display
if (this.currentprofile>0)
{
var computed_field=fireform_getstring("computed_field.desc");

for(i in cp)
{
if (displayed[i]) continue;
var disable=(cp[i].desc==computed_field);

var gb=document.createElement("groupbox");gb.setAttribute("orient","vertical");gb.id="gb"+i;

var k=i;
var group=Array();
do // group by desc & value
{
if ((cp[i].desc==cp[k].desc) && (cp[i].value==cp[k].value) ) 
  {displayed[k]=i;
   group[group.length]=k;
   fireform_setup.create_trigger_line(gb,k,disable);
  }  
k++;
} while (k<cp.length && (cp[i].desc+cp[i].value)!="");
fireform_setup.create_trigger_box(gb,i,disable,group);
rows.appendChild(gb);
} //for i

}//if

} //display_profile

fireform_setup.add_new_trigger=function(num)
{ 
var gb=document.getElementById("gb"+num);
var cp=this.profs[this.currentprofile];
var last=cp.length;
var trigger_label=fireform_getstring("label.trigger");
var url_label=fireform_getstring("label.url");
if (!document.getElementById("triggerline"+num)) last=num;//recover last place
cp[last]=new fireform_profile(cp[num].desc,cp[num].value,"","");
fireform_setup.create_trigger_line(gb,last,false);
} //add_new_trigger

fireform_setup.add_new_field=function(num)
{ 
var rows=document.getElementById("rows");
var cp=this.profs[this.currentprofile];
var last=cp.length;
var gb=document.createElement("groupbox");gb.setAttribute("orient","vertical");gb.id="gb"+last;
cp[last]=new fireform_profile("","","","");
fireform_setup.create_trigger_box(gb,last,false,[last]);
fireform_setup.create_trigger_line(gb,last,false);
rows.appendChild(gb);
gb.lastChild.firstChild.lastChild.focus();
gb.firstChild.firstChild.firstChild.nextSibling.focus(); //ahem...
} //add_new_field

fireform_setup.del_trigger=function(num)
{ 
var cp=this.profs[this.currentprofile];
cp[num].trigger=cp[num].url="";
var ch=document.getElementById("triggerline"+num);
ch.parentNode.removeChild(ch);
}

fireform_setup.display_simple_profile=function()
{

var grbase=document.getElementById("grbase");
while(grbase.firstChild) grbase.removeChild(grbase.firstChild); //remove previous display

var cp=this.profs[this.currentprofile];
var cc=true;
var displayed=Array();
for(var i in this.groups) 
{
if (cc) {var container=document.createElement("row");container.id="cont"+i;container.setAttribute("flex","1");
document.getElementById("grbase").appendChild(container);}
cc=!cc;

var gr=document.createElement("groupbox");gr.id="group"+i;gr.setAttribute("flex","1");
var cap=document.createElement("caption");cap.id="cap"+i;//cap.setAttribute("flex","1");
cap.setAttribute("label",this.groups[i].name);
gr.appendChild(cap);
	for (var j in cp)
	{if (displayed[j]) continue;
	if ((cp[j].desc) && ((";"+this.groups[i].childs+";").toLowerCase().indexOf(";"+cp[j].desc.toLowerCase()+";"))>=0)
	  {
	  var hbox=document.createElement("hbox");hbox.id="hbox"+j;
	  var lab=document.createElement("label");lab.id="lab"+j;
	  lab.setAttribute("value",cp[j].desc+" : ");
	  lab.setAttribute("control","box"+j);
	  hbox.appendChild(lab);
	  var tb=document.createElement("textbox");tb.id="box"+j;
	  tb.setAttribute("class","input");
	  tb.setAttribute("type","text");
	  tb.setAttribute("value",cp[j].value.split(";")[0]);
	  	  
	  var k=j;
	  var cattrib="";
	  do // group by desc & value
	  {	if ((cp[j].desc==cp[k].desc) && (cp[j].value==cp[k].value) ) 
		{ displayed[k]=true;
		  cattrib+="fireform_setup.profs[fireform_setup.currentprofile]["+k+"].value=event.target.value;";
		}   
	   k++;
	  } while (k<cp.length);
	  tb.setAttribute("onchange",cattrib);
	  hbox.appendChild(tb);
	  gr.appendChild(hbox);
	  }//if
	 
	}//for j
container.appendChild(gr);
}//for

} //display_simple

fireform_setup.select_profile=function()
{ 
this.currentprofile=0;
for(var i in this.profsnames)
 if (this.profsnames[i]==document.getElementById("profile_list").value) {this.currentprofile=i;break;}
this.display_profile();
}//select_profile

fireform_setup.load_groups=function()
{
var i=1;
var gr;
while ((gr=fireform_getstring("default.group"+i+".name"))!=null) 
{
this.groups[i]=new fireform_setup_group(gr,fireform_getstring("default.group"+i+".childs"));
i++;
}//while
}//load_groups

fireform_setup.load_profiles=function()
{
fireform_setup.load_fakegen=function(menu)
{
var c=document.getElementById(menu).menupopup.firstChild;
while ( (c!=null) & (c.getAttribute("myval")!=this.options[menu])) c=c.nextSibling;
if (c!=null) document.getElementById(menu).selectedItem=c;
}//load_fakegen

fireform_setup.load_groups();
var nbprofs=0;

while (fireform_prefs.prefHasUserValue("profiles.prof"+(nbprofs+1)+".name")) 
{
nbprofs++;
this.profs[nbprofs]=new Array();
this.profsnames[nbprofs]=fireform_prefs.getCharPref("profiles.prof"+nbprofs+".name");
document.getElementById("profile_list").appendItem(this.profsnames[nbprofs],this.profsnames[nbprofs]);

fireform_load1prof(this.profs[nbprofs],nbprofs);

if (fireform_prefs.prefHasUserValue("profiles.prof"+nbprofs+".shortkey"))
   this.shortkeys[nbprofs]=fireform_prefs.getCharPref("profiles.prof"+nbprofs+".shortkey");
else this.shortkeys[nbprofs]="";
}// while nbprofs

this.currentprofile=0;
if (fireform_prefs.prefHasUserValue("currentprofile")) 
 { 
  this.currentprofile=parseInt(fireform_prefs.getCharPref("currentprofile"));
  document.getElementById("profile_list").selectedIndex=this.currentprofile-1;
  this.display_profile();
 }
if (fireform_prefs.prefHasUserValue("version")) this.version=fireform_prefs.getCharPref("version");
else this.version="0.0";
// if (this.version<"0.3")  fireform_localert("oldprofile"); // bug on macintosh?

fireform_load_options(this.options);
document.getElementById("overwrite_fields").checked=this.options.overwrite;
document.getElementById("onlyonce_fields").checked=this.options.onlyonce;

fireform_setup.load_fakegen("fgcountry");
fireform_setup.load_fakegen("fglanguage");
fireform_setup.load_fakegen("fggender");
}//load_profiles
			

fireform_setup.save_profiles=function()
{
var calmonths=fireform_getstring("calendar_months").split(";");
var computed_field=fireform_getstring("computed_field.desc");

var keyset=parent.document.getElementById("mainKeyset");

fireform_prefs.deleteBranch("profiles");
var profnum=0;
var newcurrent=0;
for(var i in this.profs)
{ 
profnum++;
if (i==this.currentprofile) newcurrent=profnum;
fireform_prefs.setCharPref("profiles.prof"+profnum+".name",this.profsnames[i]);

if ((this.shortkeys[i]) && (this.shortkeys[i]!=""))
	fireform_prefs.setCharPref("profiles.prof"+profnum+".shortkey",this.shortkeys[i]);

var fieldnum=0;
var cp=this.profs[i];
for(var j in cp)
{
if (!document.getElementById("fireform_setup_dialog")) 
{// simple setup, complete some fields, not nice but works...
 if (cp[j].desc==fireform_getstring("birthday"))
 { var birthday=(cp[j].value+'').split(";")[0];
   cp[j].value=birthday;
   if ((birthday<10) && (birthday>0)) cp[j].value+=";"+parseInt(birthday);
 }  
 if (cp[j].desc==fireform_getstring("birthmonth")) 
 { var birthmonth=(cp[j].value+'').split(";")[0];
   cp[j].value=birthmonth;
   if ((birthmonth<10) && (birthmonth>0)) cp[j].value+=";"+parseInt(birthmonth);
   if ((birthmonth<=12) && (birthmonth>0)) cp[j].value+=";"+calmonths[birthmonth-1];
 } //if
 if (cp[j].desc==fireform_getstring("title"))
   { var title=cp[j].value.split(";")[0];
     var st=fireform_getstring("short_title."+title.toLowerCase());
     if (st) cp[j].value=title+";"+st;
   }//if
}//complete 

if ((cp[j].desc!=computed_field) && (cp[j].url+cp[j].trigger!=""))
 {  fieldnum++;
 	fireform_save1line(profnum,fieldnum,cp[j].desc,cp[j].value,cp[j].trigger,cp[j].url);
 }  
}// for j
}// for i

fireform_prefs.setCharPref("version", "0.5");
fireform_prefs.setCharPref("currentprofile",newcurrent);
fireform_setup.save_options();
window.close();
window.opener.fireform.shortkeys();
}//save_profiles

fireform_setup.set_option=function(option)
{// sets an optional field
if (option.id=="overwrite_fields") this.options.overwrite=option.checked;
else if (option.id=="onlyonce_fields") this.options.onlyonce=option.checked;
else this.options[option.id]=option.selectedItem.getAttribute("myval");
}//set_option

fireform_setup.save_options=function()
{// save options
//alert(this.options.overwrite);
 fireform_prefs.setBoolPref("option.overwrite",this.options.overwrite);
 fireform_prefs.setBoolPref("option.onlyonce",this.options.onlyonce);
 fireform_prefs.setCharPref("option.fgcountry",this.options.fgcountry);
 fireform_prefs.setCharPref("option.fglanguage",this.options.fglanguage);
 fireform_prefs.setCharPref("option.fggender",this.options.fggender);
}
